% Example 11-2; Equal Area Example
clc
clear all
j=sqrt(-1);
Length=100; % km
XL_km=0.367; XL = XL_km*Length;
H=3.5;
Wsyn=2*pi*60;
b=7.4272;
% SIL = 420e6; % three-phase value per line
KV_LL= 345; MVA_Base=1500; % common 3-phase base
Z_Base=KV_LL^2/MVA_Base; % common base
XL_PU=XL/Z_Base;
Xtr_PU=0.20; % Transformer base is 1500 MVA
XdP_PU=0.28; % Generator base is 1500MVA; 22kV_LL
VB=1; %infinite bus voltage in per unit as a reference phasor
Pm=1500; % mechanical input in MW (three-phase)
Pm_PU=Pm/MVA_Base; Pe_Pre=Pm_PU;
% Pre-Fault (Pre) steady state
V1_Mag_Pre=1.05; % voltage mag at bus 1 in per unit
XT_Pre=XdP_PU+Xtr_PU+XL_PU/2; % two lines in parallel
delta_V1_Pre=asin(Pe_Pre*(XL_PU/2)/(VB*V1_Mag_Pre)) % in radians
V1_Pre=V1_Mag_Pre*(cos(delta_V1_Pre)+j*sin(delta_V1_Pre));
I=(V1_Pre-VB)/(j*XL_PU/2);
EP=V1_Pre+j*(XdP_PU+Xtr_PU)*I;
EP_Mag=abs(EP)
delta_1=angle(EP)
P_Peak_Pre=EP_Mag*VB/XT_Pre,
% 3-phase to ground Fault at fraction (Frac)of one of the lines from bus 1
frac=0.2;
XTH=XL_PU*(1*frac)/(1+frac); VTH=VB*(frac)/(1+frac);
XT_Fault=XdP_PU+Xtr_PU+XTH;
P_Peak_Fault=EP_Mag*VTH/XT_Fault,
% Post-fault condition with one line removed
XT_Post=XdP_PU+Xtr_PU+XL_PU; 
P_Peak_Post=EP_Mag*VB/XT_Post,
% Plotting of power-angle curves
deldeg=[0:0.1:180]; del=deldeg*pi/180;
plot(deldeg,P_Peak_Pre*sin(del),deldeg,P_Peak_Fault*sin(del),deldeg,P_Peak_Post*sin(del),deldeg,Pm_PU)
% Equal Area Calculations
delta_2=asin(1/P_Peak_Post)
delta_critical=1.05635 % computed using equal area criteria
t_critical=0.1514;  %observed from the simulation
t_clear=0.15




