!=======================================================================
! Generated by  : PSCAD v4.2.1
!
! Warning:  The content of this file is automatically generated.
!           Do not modify, as any changes made here will be lost!
!-----------------------------------------------------------------------
! Component     : Main
! Description   : 
!-----------------------------------------------------------------------


!=======================================================================

      SUBROUTINE DSDyn()

!---------------------------------------
! Standard includes
!---------------------------------------

      INCLUDE 'nd.h'
      INCLUDE 'emtconst.h'
      INCLUDE 'emtstor.h'
      INCLUDE 's0.h'
      INCLUDE 's1.h'
      INCLUDE 's2.h'
      INCLUDE 's4.h'
      INCLUDE 'branches.h'
      INCLUDE 'pscadv3.h'
      INCLUDE 'fnames.h'
      INCLUDE 'radiolinks.h'
      INCLUDE 'matlab.h'

!---------------------------------------
! Function/Subroutine Declarations
!---------------------------------------

      REAL    EMTDC_VVDC    ! 
!     SUBR    PREINSERT3    ! Pre-Post insertion resistor branch for 1 phase breaker
!     SUBR    3PHVSRC       ! 3-Phase Source model

!---------------------------------------
! Variable Declarations
!---------------------------------------


! Subroutine Parameters

! Electrical Node Indexes
      INTEGER NT_3(3), NT_4(3)

! Control Signals
      INTEGER BRKA, BRKB, BRKC
      REAL    Ia, Ea, Eb, Ec

! Internal Variables
      INTEGER B_Stt1, B_Stt2, B_Stt3, ISTORI
      INTEGER I_BRKA, I_BRKB, I_BRKC, I_PRBPA
      INTEGER I_PRBPB, I_PRBPC
      REAL    V_BRA, V_BRB, V_BRC, E_MAG, F_RAD
      REAL    R_PH

! Indexing variables
      INTEGER ISTOI, ISTOF, IT_0                  ! Storage Indexes
      INTEGER IPGB                                ! Control/Monitoring
      INTEGER ISUBS, SS(1), IBRCH(1), INODE       ! SS/Node/Branch/Xfmr


!---------------------------------------
! Record local indexes
!---------------------------------------

! Dsdyn <-> Dsout transfer index storage
      NTXFR = NTXFR + 1
      TXFR(NTXFR,1) = NSTOL
      TXFR(NTXFR,2) = NSTOI
      TXFR(NTXFR,3) = NSTOF

! Record Offset and Increment Storage Counters
      ISTOI     = NSTOI
      NSTOI     = NSTOI + 3
      ISTOF     = NSTOF
      NSTOF     = NSTOF + 4
      IPGB      = NPGB
      NPGB      = NPGB + 4
      INODE     = NNODE + 2
      NNODE     = NNODE + 11

! Initialize Subsystem Mapping

      ISUBS = NSUBS + 0
      NSUBS = NSUBS + 1

      DO 100  IT_0 = 1,1
         SS(IT_0) = SUBS(ISUBS + IT_0)
  100 CONTINUE

! Initialize Branch Mapping.

      IBRCH(1)     = NBRCH(SS(1))
      NBRCH(SS(1)) = NBRCH(SS(1)) + 9

!---------------------------------------
! Transfers from storage arrays
!---------------------------------------

      Ia       = STOF(ISTOF + 1)
      BRKA     = STOI(ISTOI + 1)
      Ea       = STOF(ISTOF + 2)
      Eb       = STOF(ISTOF + 3)
      Ec       = STOF(ISTOF + 4)
      BRKB     = STOI(ISTOI + 2)
      BRKC     = STOI(ISTOI + 3)

!---------------------------------------
! Transfer from Imports
!---------------------------------------


!---------------------------------------
! Electrical Node Lookup
!---------------------------------------


! Array(1:3) quantities...
      DO 101  IT_0 = 1,3
         NT_3(IT_0) = NODE(INODE + 2 + IT_0)
         NT_4(IT_0) = NODE(INODE + 5 + IT_0)
  101 CONTINUE

!---------------------------------------
! Read Model data (if any)
!---------------------------------------

      IF ( TIMEZERO ) THEN
         FILENAME = 'Main.dta'
         CALL EMTDC_OPENFILE
         SECTION = 'DATADSD:'
         CALL EMTDC_GOTOSECTION
      ENDIF

!---------------------------------------
! Generated code from module definition
!---------------------------------------


! 10:[tbreakn] Timed Breaker Logic 
! Timed breaker logic
      IF ( TIMEZERO ) THEN
         BRKA = 1
      ELSE
         BRKA = 1
         IF ( TIME .GE. 0.0 ) BRKA = (1-1)
      ENDIF

! 20:[tbreakn] Timed Breaker Logic 
! Timed breaker logic
      IF ( TIMEZERO ) THEN
         BRKB = 1
      ELSE
         BRKB = 1
         IF ( TIME .GE. 0.0 ) BRKB = (1-1)
      ENDIF

! 30:[tbreakn] Timed Breaker Logic 
! Timed breaker logic
      IF ( TIMEZERO ) THEN
         BRKC = 1
      ELSE
         BRKC = 1
         IF ( TIME .GE. 0.0 ) BRKC = (1-1)
      ENDIF

! 40:[breaker3] 3 Phase Breaker 'BRK'
      V_BRA = EMTDC_VVDC(SS(1), NT_4(1), NT_3(1))
      V_BRB = EMTDC_VVDC(SS(1), NT_4(2), NT_3(2))
      V_BRC = EMTDC_VVDC(SS(1), NT_4(3), NT_3(3))
      ISTORI = NSTORI
      NSTORI = NSTORI + 3
!  Breaker and Pre-Post Insertion Resistor Branches
      CALL PREINSERT11(NINT(REAL(BRKA)),0,0.05,0.0,0.005,V_BRA,I_BRKA,I_&
     &PRBPA)
      CALL PREINSERT11(NINT(REAL(BRKB)),0,0.05,0.0,0.005,V_BRB,I_BRKB,I_&
     &PRBPB)
      CALL PREINSERT11(NINT(REAL(BRKC)),0,0.05,0.0,0.005,V_BRC,I_BRKC,I_&
     &PRBPC)
!
      CALL EMTDC_BREAKER1(SS(1), (IBRCH(1)+4),0.1,2000000.0,0.0,0,I_BRKA&
     &)
      CALL EMTDC_BREAKER1(SS(1), (IBRCH(1)+7),50.0,2000000.0,0.0,0,I_PRB&
     &PA)
      CALL EMTDC_BREAKER1(SS(1), (IBRCH(1)+5),0.1,2000000.0,0.0,0,I_BRKB&
     &)
      CALL EMTDC_BREAKER1(SS(1), (IBRCH(1)+8),50.0,2000000.0,0.0,0,I_PRB&
     &PB)
      CALL EMTDC_BREAKER1(SS(1), (IBRCH(1)+6),0.1,2000000.0,0.0,0,I_BRKC&
     &)
      CALL EMTDC_BREAKER1(SS(1), (IBRCH(1)+9),50.0,2000000.0,0.0,0,I_PRB&
     &PC)
!
      B_Stt1  = E_BtoI(OPENBR( (IBRCH(1)+4),SS(1))) + E_BtoI(OPENBR( (IB&
     &RCH(1)+7),SS(1)))
      B_Stt2  = E_BtoI(OPENBR( (IBRCH(1)+5),SS(1))) + E_BtoI(OPENBR( (IB&
     &RCH(1)+8),SS(1)))
      B_Stt3  = E_BtoI(OPENBR( (IBRCH(1)+6),SS(1))) + E_BtoI(OPENBR( (IB&
     &RCH(1)+9),SS(1)))
      IF (FIRSTSTEP .OR. (STORI(ISTORI+0) .NE. B_Stt1)) THEN
         CALL PSCAD_AGI(25953280,B_Stt1,"BOpen1")
      ENDIF
      IF (FIRSTSTEP .OR. (STORI(ISTORI+1) .NE. B_Stt2)) THEN
         CALL PSCAD_AGI(25953280,B_Stt2,"BOpen2")
      ENDIF
      IF (FIRSTSTEP .OR. (STORI(ISTORI+2) .NE. B_Stt3)) THEN
         CALL PSCAD_AGI(25953280,B_Stt3,"BOpen3")
      ENDIF
      STORI(ISTORI+0) = E_BtoI(OPENBR( (IBRCH(1)+4),SS(1))) + E_BtoI(OPE&
     &NBR( (IBRCH(1)+7),SS(1)))
      STORI(ISTORI+1) = E_BtoI(OPENBR( (IBRCH(1)+5),SS(1))) + E_BtoI(OPE&
     &NBR( (IBRCH(1)+8),SS(1)))
      STORI(ISTORI+2) = E_BtoI(OPENBR( (IBRCH(1)+6),SS(1))) + E_BtoI(OPE&
     &NBR( (IBRCH(1)+9),SS(1)))

! 80:[source_3] Three Phase Voltage Source Model 2 'Source 1'
! Three Phase Source: Source 1  Type: R
!  Mag: 281.69132042 kV, Freq: 60.0 Hz, Phase: 0.0 degs, StartUp: 0.0 sec
      E_MAG = 281.69132042
      F_RAD = 376.991118431
      R_PH  = 0.0*PI_BY180
      CALL EMTDC_3PHVSRC(SS(1), (IBRCH(1)+1), (IBRCH(1)+2), (IBRCH(1)+3)&
     &, 0.0, .TRUE., E_MAG , F_RAD, R_PH)
!

! 110:[pgb] Output Channel 'Ia'

      PGB(IPGB+3) = Ia

!---------------------------------------
! Feedbacks and transfers to storage
!---------------------------------------

      STOF(ISTOF + 1) = Ia
      STOI(ISTOI + 1) = BRKA
      STOF(ISTOF + 2) = Ea
      STOF(ISTOF + 3) = Eb
      STOF(ISTOF + 4) = Ec
      STOI(ISTOI + 2) = BRKB
      STOI(ISTOI + 3) = BRKC

!---------------------------------------
! Transfer to Exports
!---------------------------------------

!---------------------------------------
! Close Model Data read
!---------------------------------------

      IF ( TIMEZERO ) CALL EMTDC_CLOSEFILE
      RETURN
      END

!=======================================================================

      SUBROUTINE DSOut()

!---------------------------------------
! Standard includes
!---------------------------------------

      INCLUDE 'nd.h'
      INCLUDE 'emtconst.h'
      INCLUDE 'emtstor.h'
      INCLUDE 's0.h'
      INCLUDE 's1.h'
      INCLUDE 's2.h'
      INCLUDE 's4.h'
      INCLUDE 'branches.h'
      INCLUDE 'pscadv3.h'
      INCLUDE 'fnames.h'
      INCLUDE 'radiolinks.h'
      INCLUDE 'matlab.h'

!---------------------------------------
! Function/Subroutine Declarations
!---------------------------------------

      REAL    EMTDC_VVDC    ! 

!---------------------------------------
! Variable Declarations
!---------------------------------------


! Electrical Node Indexes
      INTEGER NT_1, NT_2, NT_5

! Control Signals
      REAL    Ia, Ea, Eb, Ec

! Internal Variables
      INTEGER IVD1_1
      REAL    P_1, Q_1

! Indexing variables
      INTEGER ISTOL, ISTOI, ISTOF, IT_0           ! Storage Indexes
      INTEGER IPGB                                ! Control/Monitoring
      INTEGER ISUBS, SS(1), IBRCH(1), INODE       ! SS/Node/Branch/Xfmr


!---------------------------------------
! Record local indexes
!---------------------------------------

! Dsdyn <-> Dsout transfer index storage
      NTXFR = NTXFR + 1
      ISTOL = TXFR(NTXFR,1)
      ISTOI = TXFR(NTXFR,2)
      ISTOF = TXFR(NTXFR,3)

! Record Offset and Increment Storage Counters
      IPGB      = NPGB
      NPGB      = NPGB + 4
      INODE     = NNODE + 2
      NNODE     = NNODE + 11

! Initialize Subsystem Mapping

      ISUBS = NSUBS + 0
      NSUBS = NSUBS + 1

      DO 100  IT_0 = 1,1
         SS(IT_0) = SUBS(ISUBS + IT_0)
  100 CONTINUE

! Initialize Branch Mapping.

      IBRCH(1)     = NBRCH(SS(1))
      NBRCH(SS(1)) = NBRCH(SS(1)) + 9

!---------------------------------------
! Transfers from storage arrays
!---------------------------------------

      Ia       = STOF(ISTOF + 1)
      Ea       = STOF(ISTOF + 2)
      Eb       = STOF(ISTOF + 3)
      Ec       = STOF(ISTOF + 4)

!---------------------------------------
! Electrical Node Lookup
!---------------------------------------

      NT_1  = NODE(INODE + 1)
      NT_2  = NODE(INODE + 2)
      NT_5  = NODE(INODE + 9)

!---------------------------------------
! Read Model data (if any)
!---------------------------------------

      IF ( TIMEZERO ) THEN
         FILENAME = 'Main.dta'
         CALL EMTDC_OPENFILE
         SECTION = 'DATADSO:'
         CALL EMTDC_GOTOSECTION
      ENDIF

!---------------------------------------
! Generated code from module definition
!---------------------------------------


! 40:[breaker3] 3 Phase Breaker 'BRK'
!  Breaker and Pre-Post Insertion Resistor Branch Currents
      CALL BRK_POWER(SS(1), (IBRCH(1)+4), (IBRCH(1)+5), (IBRCH(1)+6), (I&
     &BRCH(1)+7), (IBRCH(1)+8), (IBRCH(1)+9),IVD1_1,0.02,P_1,Q_1)

! 50:[voltmetergnd] Voltmeter (Line - Ground) 'Ea'
      Ea = EMTDC_VVDC(SS(1), NT_1, 0)

! 60:[voltmetergnd] Voltmeter (Line - Ground) 'Eb'
      Eb = EMTDC_VVDC(SS(1), NT_2, 0)

! 70:[voltmetergnd] Voltmeter (Line - Ground) 'Ec'
      Ec = EMTDC_VVDC(SS(1), NT_5, 0)

! 80:[source_3] Three Phase Voltage Source Model 2 'Source 1'
      Ia = ( CBR((IBRCH(1)+1), SS(1)))

! 90:[pgb] Output Channel 'Ec'

      PGB(IPGB+1) = Ec

! 100:[pgb] Output Channel 'Eb'

      PGB(IPGB+2) = Eb

! 120:[pgb] Output Channel 'Ea'

      PGB(IPGB+4) = Ea

!---------------------------------------
! Feedbacks and transfers to storage
!---------------------------------------

      STOF(ISTOF + 1) = Ia
      STOF(ISTOF + 2) = Ea
      STOF(ISTOF + 3) = Eb
      STOF(ISTOF + 4) = Ec

!---------------------------------------
! Close Model Data read
!---------------------------------------

      IF ( TIMEZERO ) CALL EMTDC_CLOSEFILE
      RETURN
      END

